<html>
<head>
<title>OgreCompositorChain.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreCompositorChain.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreCompositorChain_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __CompositorChain_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __CompositorChain_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderTargetListener_8h.html">OgreRenderTargetListener.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderQueueListener_8h.html">OgreRenderQueueListener.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreCompositorInstance_8h.html">OgreCompositorInstance.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreCompositor_8h.html">OgreCompositor.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreViewport_8h.html">OgreViewport.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00047"></a><a class="code" href="classOgre_1_1CompositorChain.html">00047</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1CompositorChain.html" title="Chain of compositor effects applying to one viewport.">CompositorChain</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderTargetListener.html" title="A interface class defining a listener which can be used to receive notifications of RenderTarget even...">RenderTargetListener</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>::Listener, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">CompositorInstAlloc</a>
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049     <span class="keyword">public</span>:
<a name="l00050"></a>00050         <a class="code" href="classOgre_1_1CompositorChain.html" title="Chain of compositor effects applying to one viewport.">CompositorChain</a>(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp);
<a name="l00055"></a>00055         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1CompositorChain.html" title="Chain of compositor effects applying to one viewport.">CompositorChain</a>();
<a name="l00056"></a>00056         
<a name="l00058"></a><a class="code" href="classOgre_1_1CompositorChain.html#ac6b8bed59c322b3466fd61a0663923e6">00058</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;CompositorInstance*&gt;::type</a> <a class="code" href="classOgre_1_1CompositorChain.html#ac6b8bed59c322b3466fd61a0663923e6" title="Data types.">Instances</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1CompositorChain.html#ab6a0110a3e6e1cc2c45a6aa7e6d15e20">00059</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;Instances&gt;</a> <a class="code" href="classOgre_1_1CompositorChain.html#ab6a0110a3e6e1cc2c45a6aa7e6d15e20">InstanceIterator</a>;
<a name="l00060"></a>00060         
<a name="l00062"></a><a class="code" href="classOgre_1_1CompositorChain.html#a12a007f299024321e7c826e0c069e903">00062</a>         <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">size_t</span> LAST = (size_t)-1;
<a name="l00064"></a><a class="code" href="classOgre_1_1CompositorChain.html#a168c3bd702ad4e598d2765ba8ddb8c1b">00064</a>         <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">size_t</span> BEST = 0;
<a name="l00065"></a>00065         
<a name="l00071"></a>00071         <a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>* addCompositor(<a class="code" href="classOgre_1_1CompositorPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to CompositorPtr.">CompositorPtr</a> filter, <span class="keywordtype">size_t</span> addPosition=LAST, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; scheme = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00072"></a>00072 
<a name="l00076"></a>00076         <span class="keywordtype">void</span> removeCompositor(<span class="keywordtype">size_t</span> position=LAST);
<a name="l00077"></a>00077         
<a name="l00080"></a>00080         <span class="keywordtype">size_t</span> getNumCompositors();
<a name="l00081"></a>00081         
<a name="l00084"></a>00084         <span class="keywordtype">void</span> removeAllCompositors();
<a name="l00085"></a>00085         
<a name="l00088"></a>00088         <a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a> *getCompositor(<span class="keywordtype">size_t</span> index);
<a name="l00089"></a>00089 
<a name="l00092"></a>00092         <a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a> *getCompositor(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00093"></a>00093 
<a name="l00096"></a><a class="code" href="classOgre_1_1CompositorChain.html#a7655532cf0ded63f91cbfb2063d98875">00096</a>         <a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>* <a class="code" href="classOgre_1_1CompositorChain.html#a7655532cf0ded63f91cbfb2063d98875" title="Get the original scene compositor instance for this chain (internal use).">_getOriginalSceneCompositor</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mOriginalScene; }
<a name="l00097"></a>00097 
<a name="l00100"></a>00100         InstanceIterator getCompositors();
<a name="l00101"></a>00101     
<a name="l00107"></a>00107         <span class="keywordtype">void</span> setCompositorEnabled(<span class="keywordtype">size_t</span> position, <span class="keywordtype">bool</span> state);
<a name="l00108"></a>00108 
<a name="l00110"></a>00110         <span class="keyword">virtual</span> <span class="keywordtype">void</span> preRenderTargetUpdate(<span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderTargetEvent.html" title="Struct containing information about a RenderTarget event.">RenderTargetEvent</a>&amp; evt);
<a name="l00112"></a>00112         <span class="keyword">virtual</span> <span class="keywordtype">void</span> postRenderTargetUpdate(<span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderTargetEvent.html" title="Struct containing information about a RenderTarget event.">RenderTargetEvent</a>&amp; evt);
<a name="l00114"></a>00114         <span class="keyword">virtual</span> <span class="keywordtype">void</span> preViewportUpdate(<span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderTargetViewportEvent.html" title="Struct containing information about a RenderTarget Viewport-specific event.">RenderTargetViewportEvent</a>&amp; evt);
<a name="l00116"></a>00116         <span class="keyword">virtual</span> <span class="keywordtype">void</span> postViewportUpdate(<span class="keyword">const</span> <a class="code" href="structOgre_1_1RenderTargetViewportEvent.html" title="Struct containing information about a RenderTarget Viewport-specific event.">RenderTargetViewportEvent</a>&amp; evt);
<a name="l00117"></a>00117 
<a name="l00119"></a>00119         <span class="keyword">virtual</span> <span class="keywordtype">void</span> viewportCameraChanged(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* viewport);
<a name="l00121"></a>00121         <span class="keyword">virtual</span> <span class="keywordtype">void</span> viewportDimensionsChanged(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* viewport);
<a name="l00123"></a>00123         <span class="keyword">virtual</span> <span class="keywordtype">void</span> viewportDestroyed(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* viewport);
<a name="l00124"></a>00124 
<a name="l00127"></a>00127         <span class="keywordtype">void</span> _markDirty();
<a name="l00128"></a>00128         
<a name="l00131"></a>00131         <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *getViewport();
<a name="l00132"></a>00132 
<a name="l00136"></a>00136         <span class="keywordtype">void</span> _removeInstance(<a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a> *i);
<a name="l00137"></a>00137 
<a name="l00139"></a>00139         <span class="keywordtype">void</span> _queuedOperation(<a class="code" href="classOgre_1_1CompositorInstance_1_1RenderSystemOperation.html" title="Specific render system operation.">CompositorInstance::RenderSystemOperation</a>* op);
<a name="l00140"></a>00140 
<a name="l00143"></a>00143         <span class="keywordtype">void</span> _compile();
<a name="l00144"></a>00144 
<a name="l00147"></a>00147         <a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>* getPreviousInstance(<a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>* curr, <span class="keywordtype">bool</span> activeOnly = <span class="keyword">true</span>);
<a name="l00150"></a>00150         <a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>* getNextInstance(<a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>* curr, <span class="keywordtype">bool</span> activeOnly = <span class="keyword">true</span>);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152     <span class="keyword">protected</span>:
<a name="l00154"></a><a class="code" href="classOgre_1_1CompositorChain.html#a584ed2008fb3617e586e9be48d61071c">00154</a>         <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *<a class="code" href="classOgre_1_1CompositorChain.html#a584ed2008fb3617e586e9be48d61071c" title="Viewport affected by this CompositorChain.">mViewport</a>;
<a name="l00155"></a>00155         
<a name="l00158"></a><a class="code" href="classOgre_1_1CompositorChain.html#ac670c7beb3e20ed90fc527421bdc41ba">00158</a>         <a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a> *<a class="code" href="classOgre_1_1CompositorChain.html#ac670c7beb3e20ed90fc527421bdc41ba" title="Plainly renders the scene; implicit first compositor in the chain.">mOriginalScene</a>;
<a name="l00159"></a>00159         
<a name="l00161"></a><a class="code" href="classOgre_1_1CompositorChain.html#ae3d506995ac8ad8aa48270e5ea1c7f13">00161</a>         <a class="code" href="classOgre_1_1CompositorChain.html#ac6b8bed59c322b3466fd61a0663923e6" title="Data types.">Instances</a> <a class="code" href="classOgre_1_1CompositorChain.html#ae3d506995ac8ad8aa48270e5ea1c7f13" title="Postfilter instances in this chain.">mInstances</a>;
<a name="l00162"></a>00162         
<a name="l00164"></a><a class="code" href="classOgre_1_1CompositorChain.html#a30177a879b005637889e4be4d17561ae">00164</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositorChain.html#a30177a879b005637889e4be4d17561ae" title="State needs recompile.">mDirty</a>;
<a name="l00166"></a><a class="code" href="classOgre_1_1CompositorChain.html#a7d18abb26afbcced73733296b9b203f5">00166</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositorChain.html#a7d18abb26afbcced73733296b9b203f5" title="Any compositors enabled?">mAnyCompositorsEnabled</a>;
<a name="l00167"></a>00167 
<a name="l00168"></a><a class="code" href="classOgre_1_1CompositorChain.html#a3e1a36df5f8ab70ffe1b8cd2ad83ac0f">00168</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1CompositorChain.html#a3e1a36df5f8ab70ffe1b8cd2ad83ac0f">mOriginalSceneScheme</a>;
<a name="l00169"></a>00169 
<a name="l00171"></a><a class="code" href="classOgre_1_1CompositorChain.html#a1c6ffca0e911fa96d012d9222ae48291">00171</a>         <a class="code" href="classOgre_1_1CompositorInstance.html#afc24e918e5a1f648385d3ca6df3fc281">CompositorInstance::CompiledState</a> <a class="code" href="classOgre_1_1CompositorChain.html#a1c6ffca0e911fa96d012d9222ae48291" title="Compiled state (updated with _compile)">mCompiledState</a>;
<a name="l00172"></a><a class="code" href="classOgre_1_1CompositorChain.html#a889e1ef93d03389ec01b34a70f62d1f3">00172</a>         <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html" title="Operation setup for a RenderTarget (collected).">CompositorInstance::TargetOperation</a> <a class="code" href="classOgre_1_1CompositorChain.html#a889e1ef93d03389ec01b34a70f62d1f3">mOutputOperation</a>;
<a name="l00176"></a><a class="code" href="classOgre_1_1CompositorChain.html#aab3f2d68973eeb6231db7e8fc1c349e1">00176</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;CompositorInstance::RenderSystemOperation*&gt;::type</a> <a class="code" href="classOgre_1_1CompositorChain.html#aab3f2d68973eeb6231db7e8fc1c349e1" title="Render System operations queued by last compile, these are created by this instance thus managed and ...">RenderSystemOperations</a>;
<a name="l00177"></a><a class="code" href="classOgre_1_1CompositorChain.html#a2000a0428258a1d0d6d39724b0e92201">00177</a>         <a class="code" href="classOgre_1_1CompositorChain.html#aab3f2d68973eeb6231db7e8fc1c349e1" title="Render System operations queued by last compile, these are created by this instance thus managed and ...">RenderSystemOperations</a> <a class="code" href="classOgre_1_1CompositorChain.html#a2000a0428258a1d0d6d39724b0e92201">mRenderSystemOperations</a>;
<a name="l00178"></a>00178 
<a name="l00180"></a>00180         <span class="keywordtype">void</span> clearCompiledState();
<a name="l00181"></a>00181         
<a name="l00184"></a>00184         <span class="keywordtype">void</span> preTargetOperation(<a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html" title="Operation setup for a RenderTarget (collected).">CompositorInstance::TargetOperation</a> &amp;op, <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp, <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *cam);
<a name="l00185"></a>00185         
<a name="l00188"></a>00188         <span class="keywordtype">void</span> postTargetOperation(<a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html" title="Operation setup for a RenderTarget (collected).">CompositorInstance::TargetOperation</a> &amp;op, <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp, <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *cam);
<a name="l00189"></a>00189 
<a name="l00190"></a>00190         <span class="keywordtype">void</span> createOriginalScene();
<a name="l00191"></a>00191         <span class="keywordtype">void</span> destroyOriginalScene();
<a name="l00192"></a>00192 
<a name="l00194"></a>00194         <span class="keywordtype">void</span> destroyResources(<span class="keywordtype">void</span>);
<a name="l00195"></a>00195 
<a name="l00197"></a><a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html">00197</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html" title="Render queue listener used to set up rendering events.">RQListener</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderQueueListener.html" title="Abstract interface which classes must implement if they wish to receive events from the render queue...">RenderQueueListener</a>
<a name="l00198"></a>00198         {
<a name="l00199"></a>00199         <span class="keyword">public</span>:
<a name="l00202"></a>00202             <span class="keyword">virtual</span> <span class="keywordtype">void</span> renderQueueStarted(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <span class="keywordtype">id</span>, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; invocation, <span class="keywordtype">bool</span>&amp; skipThisQueue);
<a name="l00205"></a>00205             <span class="keyword">virtual</span> <span class="keywordtype">void</span> renderQueueEnded(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <span class="keywordtype">id</span>, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; invocation, <span class="keywordtype">bool</span>&amp; repeatThisQueue);
<a name="l00206"></a>00206 
<a name="l00208"></a>00208             <span class="keywordtype">void</span> setOperation(<a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html" title="Operation setup for a RenderTarget (collected).">CompositorInstance::TargetOperation</a> *op,<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> *sm,<a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a> *rs);
<a name="l00209"></a>00209 
<a name="l00211"></a><a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html#a208e4a0e0b0aedae62d3d89dab1a3d7c">00211</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html#a208e4a0e0b0aedae62d3d89dab1a3d7c" title="Notify current destination viewport.">notifyViewport</a>(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* vp) { mViewport = vp; }
<a name="l00212"></a>00212 
<a name="l00214"></a>00214             <span class="keywordtype">void</span> flushUpTo(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <span class="keywordtype">id</span>);
<a name="l00215"></a>00215         <span class="keyword">private</span>:
<a name="l00216"></a><a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html#a625fb754fa2d276a76f495a88df4b18d">00216</a>             <a class="code" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html" title="Operation setup for a RenderTarget (collected).">CompositorInstance::TargetOperation</a> *<a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html#a625fb754fa2d276a76f495a88df4b18d">mOperation</a>;
<a name="l00217"></a><a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html#a4b54c7adb7c8a898912115845ee65bb0">00217</a>             <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> *<a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html#a4b54c7adb7c8a898912115845ee65bb0">mSceneManager</a>;
<a name="l00218"></a><a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html#aa3299d89663b3a7ff40aa48710d7ce26">00218</a>             <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a> *<a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html#aa3299d89663b3a7ff40aa48710d7ce26">mRenderSystem</a>;
<a name="l00219"></a><a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html#a75c5649c0d7d1c9d1b8214bfdb3cf84a">00219</a>             <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* <a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html#a75c5649c0d7d1c9d1b8214bfdb3cf84a">mViewport</a>;
<a name="l00220"></a><a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html#a403885e6bad3a4dda4ac482f6ce9ae68">00220</a>             CompositorInstance::RenderSystemOpPairs::iterator currentOp, <a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html#a403885e6bad3a4dda4ac482f6ce9ae68">lastOp</a>;
<a name="l00221"></a>00221         };
<a name="l00222"></a><a class="code" href="classOgre_1_1CompositorChain.html#a10696f59831cee75561c0c2099b5d7be">00222</a>         <a class="code" href="classOgre_1_1CompositorChain_1_1RQListener.html" title="Render queue listener used to set up rendering events.">RQListener</a> <a class="code" href="classOgre_1_1CompositorChain.html#a10696f59831cee75561c0c2099b5d7be">mOurListener</a>;
<a name="l00224"></a><a class="code" href="classOgre_1_1CompositorChain.html#ae802fec376168b0009e91d9d2b52a32a">00224</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1CompositorChain.html#ae802fec376168b0009e91d9d2b52a32a" title="Old viewport settings.">mOldClearEveryFrameBuffers</a>;
<a name="l00226"></a><a class="code" href="classOgre_1_1CompositorChain.html#af3a2826a2501abc1a39639835fe0b021">00226</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1CompositorChain.html#af3a2826a2501abc1a39639835fe0b021" title="Store old scene visibility mask.">mOldVisibilityMask</a>;
<a name="l00228"></a><a class="code" href="classOgre_1_1CompositorChain.html#a3a136f6c8be3a5b736403878766bd00f">00228</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositorChain.html#a3a136f6c8be3a5b736403878766bd00f" title="Store old find visible objects.">mOldFindVisibleObjects</a>;
<a name="l00230"></a><a class="code" href="classOgre_1_1CompositorChain.html#a99c657543a08099992f80d7d186939f0">00230</a>         <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1CompositorChain.html#a99c657543a08099992f80d7d186939f0" title="Store old camera LOD bias.">mOldLodBias</a>;
<a name="l00232"></a><a class="code" href="classOgre_1_1CompositorChain.html#ab340ff7596d3ca02abbbbac6d807b50a">00232</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1CompositorChain.html#ab340ff7596d3ca02abbbbac6d807b50a" title="Store old viewport material scheme.">mOldMaterialScheme</a>;
<a name="l00234"></a><a class="code" href="classOgre_1_1CompositorChain.html#acf5b75bbbbf8da0cfc7f8fd47183f191">00234</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositorChain.html#acf5b75bbbbf8da0cfc7f8fd47183f191" title="Store old shadows enabled flag.">mOldShadowsEnabled</a>;
<a name="l00235"></a>00235 
<a name="l00236"></a>00236     };
<a name="l00239"></a>00239 }
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
